searchNodes=[{"ref":"Yggdrasil.Adapter.Postgres.html","title":"Yggdrasil.Adapter.Postgres","module":"Yggdrasil.Adapter.Postgres","type":"module","doc":"Yggdrasil adapter for PostgreSQL. The name of the channel must be a string e.g: Subscription to channel: iex(2)&gt; channel = %Yggdrasil.Channel{ iex(2)&gt; name: &quot;my_channel&quot;, iex(2)&gt; adapter: :postgres iex(2)&gt; } iex(3)&gt; Yggdrasil.subscribe(channel) :ok iex(4)&gt; flush() {:Y_CONNECTED, %Yggdrasil.Channel{name: &quot;my_channel&quot;, (...)}} Publishing message: iex(5)&gt; Yggdrasil.publish(channel, &quot;foo&quot;) :ok Subscriber receiving message: iex(6)&gt; flush() {:Y_EVENT, %Yggdrasil.Channel{name: &quot;my_channel&quot;, (...)}, &quot;foo&quot;} The subscriber can also unsubscribe from the channel: iex(7)&gt; Yggdrasil.unsubscribe(channel) :ok iex(8)&gt; flush() {:Y_DISCONNECTED, %Yggdrasil.Channel{name: &quot;my_channel&quot;, (...)}}"},{"ref":"Yggdrasil.Adapter.Postgres.html#child_spec/1","title":"Yggdrasil.Adapter.Postgres.child_spec/1","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_backend/0","title":"Yggdrasil.Adapter.Postgres.get_backend/0","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets default backend."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_publisher_module/0","title":"Yggdrasil.Adapter.Postgres.get_publisher_module/0","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets publisher module."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_publisher_module/1","title":"Yggdrasil.Adapter.Postgres.get_publisher_module/1","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets publisher module only if the given module exists."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_subscriber_module/0","title":"Yggdrasil.Adapter.Postgres.get_subscriber_module/0","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets subscriber module."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_subscriber_module/1","title":"Yggdrasil.Adapter.Postgres.get_subscriber_module/1","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets subscriber module only if the given module exists."},{"ref":"Yggdrasil.Adapter.Postgres.html#get_transformer/0","title":"Yggdrasil.Adapter.Postgres.get_transformer/0","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Gets default transformer."},{"ref":"Yggdrasil.Adapter.Postgres.html#register/0","title":"Yggdrasil.Adapter.Postgres.register/0","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Registers adapter in Registry."},{"ref":"Yggdrasil.Adapter.Postgres.html#start_link/1","title":"Yggdrasil.Adapter.Postgres.start_link/1","module":"Yggdrasil.Adapter.Postgres","type":"function","doc":"Start task to register the adapter in the Registry."},{"ref":"Yggdrasil.Settings.Postgres.html","title":"Yggdrasil.Settings.Postgres","module":"Yggdrasil.Settings.Postgres","type":"module","doc":"This module defines the available settings for PostgreSQL in Yggdrasil."},{"ref":"Yggdrasil.Settings.Postgres.html#database/1","title":"Yggdrasil.Settings.Postgres.database/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres database. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.database() {:ok, &quot;postgres&quot;} A call to Yggdrasil.Settings.Postgres.database(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.database(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_DATABASE. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_DATABASE. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ database: :binary() # Defaults to &quot;postgres&quot; ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ database: :binary() # Defaults to &quot;postgres&quot; ]"},{"ref":"Yggdrasil.Settings.Postgres.html#database!/1","title":"Yggdrasil.Settings.Postgres.database!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres database. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.database() {:ok, &quot;postgres&quot;} Bang version of Yggdrasil.Settings.Postgres.database/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#hostname/1","title":"Yggdrasil.Settings.Postgres.hostname/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres hostname. Defaults to &quot;localhost&quot;. A call to Yggdrasil.Settings.Postgres.hostname(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.hostname(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_HOSTNAME. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_HOSTNAME. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ hostname: :binary() # Defaults to &quot;localhost&quot; ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ hostname: :binary() # Defaults to &quot;localhost&quot; ]"},{"ref":"Yggdrasil.Settings.Postgres.html#hostname!/1","title":"Yggdrasil.Settings.Postgres.hostname!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres hostname. Defaults to &quot;localhost&quot;. Bang version of Yggdrasil.Settings.Postgres.hostname/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#max_retries/1","title":"Yggdrasil.Settings.Postgres.max_retries/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres max retries for the backoff algorithm. Defaults to 3. The backoff algorithm is exponential: backoff_time = pow(2, retries) * random(1, slot) * 1_000 ms when retries &lt;= MAX_RETRIES and slot is given by the configuration variable Elixir.Yggdrasil.Settings.Postgres.slot_size/0 (defaults to 10 secs). iex&gt; Yggdrasil.Settings.Postgres.max_retries() {:ok, 3} A call to Yggdrasil.Settings.Postgres.max_retries(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.max_retries(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_MAX_RETRIES. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_MAX_RETRIES. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ max_retries: :integer() # Defaults to 3 ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ max_retries: :integer() # Defaults to 3 ]"},{"ref":"Yggdrasil.Settings.Postgres.html#max_retries!/1","title":"Yggdrasil.Settings.Postgres.max_retries!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres max retries for the backoff algorithm. Defaults to 3. The backoff algorithm is exponential: backoff_time = pow(2, retries) * random(1, slot) * 1_000 ms when retries &lt;= MAX_RETRIES and slot is given by the configuration variable Elixir.Yggdrasil.Settings.Postgres.slot_size/0 (defaults to 10 secs). iex&gt; Yggdrasil.Settings.Postgres.max_retries() {:ok, 3} Bang version of Yggdrasil.Settings.Postgres.max_retries/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#password/1","title":"Yggdrasil.Settings.Postgres.password/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres password. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.password() {:ok, &quot;postgres&quot;} A call to Yggdrasil.Settings.Postgres.password(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.password(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_PASSWORD. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_PASSWORD. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ password: :binary() # Defaults to &quot;postgres&quot; ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ password: :binary() # Defaults to &quot;postgres&quot; ]"},{"ref":"Yggdrasil.Settings.Postgres.html#password!/1","title":"Yggdrasil.Settings.Postgres.password!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres password. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.password() {:ok, &quot;postgres&quot;} Bang version of Yggdrasil.Settings.Postgres.password/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#port/1","title":"Yggdrasil.Settings.Postgres.port/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres port. Defaults to 5432. iex&gt; Yggdrasil.Settings.Postgres.port() {:ok, 5432} A call to Yggdrasil.Settings.Postgres.port(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.port(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_PORT. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_PORT. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ port: :integer() # Defaults to 5432 ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ port: :integer() # Defaults to 5432 ]"},{"ref":"Yggdrasil.Settings.Postgres.html#port!/1","title":"Yggdrasil.Settings.Postgres.port!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres port. Defaults to 5432. iex&gt; Yggdrasil.Settings.Postgres.port() {:ok, 5432} Bang version of Yggdrasil.Settings.Postgres.port/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#publisher_connections/1","title":"Yggdrasil.Settings.Postgres.publisher_connections/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"PostgreSQL amount of publisher connections. iex&gt; Yggdrasil.Settings.Postgres.publisher_connections() {:ok, 1} A call to Yggdrasil.Settings.Postgres.publisher_connections(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.publisher_connections(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_PUBLISHER_CONNECTIONS. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_PUBLISHER_CONNECTIONS. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ publisher_connections: :integer() # Defaults to 1 ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ publisher_connections: :integer() # Defaults to 1 ]"},{"ref":"Yggdrasil.Settings.Postgres.html#publisher_connections!/1","title":"Yggdrasil.Settings.Postgres.publisher_connections!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"PostgreSQL amount of publisher connections. iex&gt; Yggdrasil.Settings.Postgres.publisher_connections() {:ok, 1} Bang version of Yggdrasil.Settings.Postgres.publisher_connections/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#put_database/2","title":"Yggdrasil.Settings.Postgres.put_database/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.database/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_hostname/2","title":"Yggdrasil.Settings.Postgres.put_hostname/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.hostname/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_max_retries/2","title":"Yggdrasil.Settings.Postgres.put_max_retries/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.max_retries/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_password/2","title":"Yggdrasil.Settings.Postgres.put_password/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.password/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_port/2","title":"Yggdrasil.Settings.Postgres.put_port/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.port/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_publisher_connections/2","title":"Yggdrasil.Settings.Postgres.put_publisher_connections/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.publisher_connections/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_slot_size/2","title":"Yggdrasil.Settings.Postgres.put_slot_size/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.slot_size/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_subscriber_connections/2","title":"Yggdrasil.Settings.Postgres.put_subscriber_connections/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.subscriber_connections/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#put_username/2","title":"Yggdrasil.Settings.Postgres.put_username/2","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Puts the value to Yggdrasil.Settings.Postgres.username/0. Optionally, receives the namespace."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_database/1","title":"Yggdrasil.Settings.Postgres.reload_database/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.database/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_hostname/1","title":"Yggdrasil.Settings.Postgres.reload_hostname/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.hostname/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_max_retries/1","title":"Yggdrasil.Settings.Postgres.reload_max_retries/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.max_retries/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_password/1","title":"Yggdrasil.Settings.Postgres.reload_password/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.password/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_port/1","title":"Yggdrasil.Settings.Postgres.reload_port/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.port/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_publisher_connections/1","title":"Yggdrasil.Settings.Postgres.reload_publisher_connections/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.publisher_connections/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_slot_size/1","title":"Yggdrasil.Settings.Postgres.reload_slot_size/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.slot_size/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_subscriber_connections/1","title":"Yggdrasil.Settings.Postgres.reload_subscriber_connections/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.subscriber_connections/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#reload_username/1","title":"Yggdrasil.Settings.Postgres.reload_username/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Reloads the value for Yggdrasil.Settings.Postgres.username/0. Optionally, receives the namespace for the variable."},{"ref":"Yggdrasil.Settings.Postgres.html#slot_size/1","title":"Yggdrasil.Settings.Postgres.slot_size/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres slot size for the backoff algorithm. Defaults to 100. iex&gt; Yggdrasil.Settings.Postgres.slot_size() {:ok, 10} A call to Yggdrasil.Settings.Postgres.slot_size(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.slot_size(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_SLOT_SIZE. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_SLOT_SIZE. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ slot_size: :integer() # Defaults to 10 ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ slot_size: :integer() # Defaults to 10 ]"},{"ref":"Yggdrasil.Settings.Postgres.html#slot_size!/1","title":"Yggdrasil.Settings.Postgres.slot_size!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres slot size for the backoff algorithm. Defaults to 100. iex&gt; Yggdrasil.Settings.Postgres.slot_size() {:ok, 10} Bang version of Yggdrasil.Settings.Postgres.slot_size/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#subscriber_connections/1","title":"Yggdrasil.Settings.Postgres.subscriber_connections/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"PostgreSQL amount of subscriber connections. iex&gt; Yggdrasil.Settings.Postgres.subscriber_connections() {:ok, 1} A call to Yggdrasil.Settings.Postgres.subscriber_connections(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.subscriber_connections(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_SUBSCRIBER_CONNECTIONS. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_SUBSCRIBER_CONNECTIONS. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ subscriber_connections: :integer() # Defaults to 1 ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ subscriber_connections: :integer() # Defaults to 1 ]"},{"ref":"Yggdrasil.Settings.Postgres.html#subscriber_connections!/1","title":"Yggdrasil.Settings.Postgres.subscriber_connections!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"PostgreSQL amount of subscriber connections. iex&gt; Yggdrasil.Settings.Postgres.subscriber_connections() {:ok, 1} Bang version of Yggdrasil.Settings.Postgres.subscriber_connections/0 (fails on error)."},{"ref":"Yggdrasil.Settings.Postgres.html#username/1","title":"Yggdrasil.Settings.Postgres.username/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres username. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.username() {:ok, &quot;postgres&quot;} A call to Yggdrasil.Settings.Postgres.username(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Yggdrasil.Settings.Postgres.username(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $YGGDRASIL_POSTGRES_USERNAME. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_YGGDRASIL_POSTGRES_USERNAME. The expected application configuration would be as follows: Without namespace: config :yggdrasil, postgres: [ username: :binary() # Defaults to &quot;postgres&quot; ] With namespace e.g. My.Custom.Namespace: config :yggdrasil, My.Custom.Namespace, postgres: [ username: :binary() # Defaults to &quot;postgres&quot; ]"},{"ref":"Yggdrasil.Settings.Postgres.html#username!/1","title":"Yggdrasil.Settings.Postgres.username!/1","module":"Yggdrasil.Settings.Postgres","type":"function","doc":"Postgres username. Defaults to &quot;postgres&quot;. iex&gt; Yggdrasil.Settings.Postgres.username() {:ok, &quot;postgres&quot;} Bang version of Yggdrasil.Settings.Postgres.username/0 (fails on error)."},{"ref":"Yggdrasil.Subscriber.Adapter.Postgres.html","title":"Yggdrasil.Subscriber.Adapter.Postgres","module":"Yggdrasil.Subscriber.Adapter.Postgres","type":"module","doc":"Yggdrasil adapter for PostgreSQL. The name of the channel must be a string e.g: Subscription to channel: iex(1)&gt; channel = [name: &quot;pg_channel&quot;, adapter: :postgres] iex(2)&gt; Yggdrasil.subscribe(channel) :ok iex(3)&gt; flush() {:Y_CONNECTED, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}} Publishing message: iex(4)&gt; Yggdrasil.publish(channel, &quot;foo&quot;) :ok Subscriber receiving message: iex(5)&gt; flush() {:Y_EVENT, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}, &quot;foo&quot;} The subscriber can also unsubscribe from the channel: iex(6)&gt; Yggdrasil.unsubscribe(channel) :ok iex(7)&gt; flush() {:Y_DISCONNECTED, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}}"},{"ref":"Yggdrasil.Subscriber.Adapter.Postgres.html#child_spec/1","title":"Yggdrasil.Subscriber.Adapter.Postgres.child_spec/1","module":"Yggdrasil.Subscriber.Adapter.Postgres","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Yggdrasil.Subscriber.Adapter.Postgres.html#start_link/2","title":"Yggdrasil.Subscriber.Adapter.Postgres.start_link/2","module":"Yggdrasil.Subscriber.Adapter.Postgres","type":"function","doc":"Starts Elixir.Yggdrasil.Subscriber.Adapter.Postgres with a channel and optional options."},{"ref":"Yggdrasil.Publisher.Adapter.Postgres.html","title":"Yggdrasil.Publisher.Adapter.Postgres","module":"Yggdrasil.Publisher.Adapter.Postgres","type":"module","doc":"Yggdrasil publisher adapter for Postgres. The name of the channel must be a binary e.g: Subscription to channel: iex(1)&gt; channel = [name: &quot;pg_channel&quot;, adapter: :postgres] iex(2)&gt; Yggdrasil.subscribe(channel) :ok iex(3)&gt; flush() {:Y_CONNECTED, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}} Publishing message: iex(4)&gt; Yggdrasil.publish(channel, &quot;foo&quot;) :ok Subscriber receiving message: iex(5)&gt; flush() {:Y_EVENT, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}, &quot;foo&quot;} The subscriber can also unsubscribe from the channel: iex(6)&gt; Yggdrasil.unsubscribe(channel) :ok iex(7)&gt; flush() {:Y_DISCONNECTED, %Yggdrasil.Channel{name: &quot;pg_channel&quot;, (...)}}"},{"ref":"Yggdrasil.Publisher.Adapter.Postgres.html#child_spec/1","title":"Yggdrasil.Publisher.Adapter.Postgres.child_spec/1","module":"Yggdrasil.Publisher.Adapter.Postgres","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Yggdrasil.Publisher.Adapter.Postgres.html#publish/4","title":"Yggdrasil.Publisher.Adapter.Postgres.publish/4","module":"Yggdrasil.Publisher.Adapter.Postgres","type":"function","doc":"Publishes a message in a channel using a publisher and optional and unused options."},{"ref":"Yggdrasil.Publisher.Adapter.Postgres.html#start_link/2","title":"Yggdrasil.Publisher.Adapter.Postgres.start_link/2","module":"Yggdrasil.Publisher.Adapter.Postgres","type":"function","doc":"Starts a Postgres publisher with a namespace. Additianally you can add GenServer options."},{"ref":"Yggdrasil.Publisher.Adapter.Postgres.html#stop/3","title":"Yggdrasil.Publisher.Adapter.Postgres.stop/3","module":"Yggdrasil.Publisher.Adapter.Postgres","type":"function","doc":"Stops a Postgres publisher. Optionally, receives a stop reason (defaults to :normal) and a timeout in milliseconds (defaults to :infinity)."},{"ref":"Yggdrasil.Postgres.Connection.html","title":"Yggdrasil.Postgres.Connection","module":"Yggdrasil.Postgres.Connection","type":"module","doc":"This module defines a PostgreSQL connection."},{"ref":"Yggdrasil.Postgres.Connection.html#child_spec/1","title":"Yggdrasil.Postgres.Connection.child_spec/1","module":"Yggdrasil.Postgres.Connection","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Yggdrasil.Postgres.Connection.html#get/1","title":"Yggdrasil.Postgres.Connection.get/1","module":"Yggdrasil.Postgres.Connection","type":"function","doc":"Gets connection from a connection process."},{"ref":"Yggdrasil.Postgres.Connection.html#start_link/2","title":"Yggdrasil.Postgres.Connection.start_link/2","module":"Yggdrasil.Postgres.Connection","type":"function","doc":"Starts a PostgreSQL connection with a tag and namespace for the configuration. Additionally, it receives GenServer options."},{"ref":"Yggdrasil.Postgres.Connection.html#stop/3","title":"Yggdrasil.Postgres.Connection.stop/3","module":"Yggdrasil.Postgres.Connection","type":"function","doc":"Stops a PostgreSQL connection. Optionally, it receives a stop reason (defaults to :normal) and a timeout in milliseconds (defaults to :infinity)."},{"ref":"Yggdrasil.Postgres.Connection.html#subscribe/2","title":"Yggdrasil.Postgres.Connection.subscribe/2","module":"Yggdrasil.Postgres.Connection","type":"function","doc":"Subscribes to the connection given a tag and namespace."},{"ref":"Yggdrasil.Postgres.Connection.html#t:namespace/0","title":"Yggdrasil.Postgres.Connection.namespace/0","module":"Yggdrasil.Postgres.Connection","type":"type","doc":"Namespace for the connection."},{"ref":"Yggdrasil.Postgres.Connection.html#t:tag/0","title":"Yggdrasil.Postgres.Connection.tag/0","module":"Yggdrasil.Postgres.Connection","type":"type","doc":"Connection types."},{"ref":"Yggdrasil.Postgres.Connection.Generator.html","title":"Yggdrasil.Postgres.Connection.Generator","module":"Yggdrasil.Postgres.Connection.Generator","type":"module","doc":"This module defines a supervisor for creating connection pools on demand."},{"ref":"Yggdrasil.Postgres.Connection.Generator.html#child_spec/1","title":"Yggdrasil.Postgres.Connection.Generator.child_spec/1","module":"Yggdrasil.Postgres.Connection.Generator","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Yggdrasil.Postgres.Connection.Generator.html#get_connection/2","title":"Yggdrasil.Postgres.Connection.Generator.get_connection/2","module":"Yggdrasil.Postgres.Connection.Generator","type":"function","doc":"Gets a connection for a tag and a namespace."},{"ref":"Yggdrasil.Postgres.Connection.Generator.html#start_link/1","title":"Yggdrasil.Postgres.Connection.Generator.start_link/1","module":"Yggdrasil.Postgres.Connection.Generator","type":"function","doc":"Starts a connection pool generator."},{"ref":"Yggdrasil.Postgres.Connection.Generator.html#stop/3","title":"Yggdrasil.Postgres.Connection.Generator.stop/3","module":"Yggdrasil.Postgres.Connection.Generator","type":"function","doc":"Stops a connection pool generator. Optionally, it receives a reason (defaults to :normal) and a timeout (default to :infinity)."},{"ref":"Yggdrasil.Postgres.Connection.Pool.html","title":"Yggdrasil.Postgres.Connection.Pool","module":"Yggdrasil.Postgres.Connection.Pool","type":"module","doc":"PostgreSQL listener connection pool."},{"ref":"Yggdrasil.Postgres.Connection.Pool.html#child_spec/1","title":"Yggdrasil.Postgres.Connection.Pool.child_spec/1","module":"Yggdrasil.Postgres.Connection.Pool","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Yggdrasil.Postgres.Connection.Pool.html#get_connection/2","title":"Yggdrasil.Postgres.Connection.Pool.get_connection/2","module":"Yggdrasil.Postgres.Connection.Pool","type":"function","doc":"Gets a connection for a tag and namespace."},{"ref":"Yggdrasil.Postgres.Connection.Pool.html#start_link/3","title":"Yggdrasil.Postgres.Connection.Pool.start_link/3","module":"Yggdrasil.Postgres.Connection.Pool","type":"function","doc":"Starts a connection pool using an initial tag and namespace. Optionally, it receives some Supervisor options."},{"ref":"Yggdrasil.Postgres.Connection.Pool.html#stop/3","title":"Yggdrasil.Postgres.Connection.Pool.stop/3","module":"Yggdrasil.Postgres.Connection.Pool","type":"function","doc":"Stops a PostgreSQL listener connection pool. Optionally, it receives a stop reason (defaults to :normal) and timeout (defaults to :infinity)."},{"ref":"readme.html","title":"Yggdrasil for PostgreSQL","module":"readme","type":"extras","doc":"Yggdrasil for PostgreSQL Yggdrasil for PostgreSQL is a publisher/subscriber that: It&#39;s easy to use and configure. It&#39;s fault tolerant: recovers disconnected subscriptions. It has reconnection support: configurable exponential backoff. It has OS environment variable configuration support (useful for Distillery releases)."},{"ref":"readme.html#small-example","title":"Yggdrasil for PostgreSQL - Small example","module":"readme","type":"extras","doc":"The following example uses PostgreSQL adapter to distribute messages e.g: Given the following channel: iex&gt; channel = [name: &quot;pg_channel&quot;, adapter: :postgres] You can: Subscribe to it: iex&gt; Yggdrasil.subscribe(channel) iex&gt; flush() {:Y_CONNECTED, %Yggdrasil.Channel{...}} Publish messages to it: iex&gt; Yggdrasil.publish(channel, &quot;message&quot;) iex&gt; flush() {:Y_EVENT, %Yggdrasil.Channel{...}, &quot;message&quot;} Unsubscribe from it: iex&gt; Yggdrasil.unsubscribe(channel) iex&gt; flush() {:Y_DISCONNECTED, %Yggdrasil.Channel{...}} And additionally, you can use Yggdrasil behaviour to build a subscriber: defmodule Subscriber do use Yggdrasil def start_link do channel = [name: &quot;pg_channel&quot;, adapter: :postgres] Yggdrasil.start_link(__MODULE__, [channel]) end @impl Yggdrasil def handle_event(_channel, message, _) do IO.inspect message {:ok, nil} end end The previous Subscriber will print every message that comes from the PostgreSQL channel pg_channel."},{"ref":"readme.html#postgresql-adapter","title":"Yggdrasil for PostgreSQL - PostgreSQL adapter","module":"readme","type":"extras","doc":"The PostgreSQL adapter has the following rules: The adapter name is identified by the atom :postgres. The channel name must be a string. The transformer must encode to a string. From the transformers provided, it defaults to :default, but :json can also be used. Any backend can be used (by default is :default). The following is an example of a valid channel for both publishers and subscribers: %Yggdrasil.Channel{ name: &quot;pg_channel&quot;, adapter: :postgres, transformer: :json } The previous channel expects to: Subscribe to or publish to the channel pg_channel. The adapter is :postgres, so it will connect to PostgreSQL using the appropriate adapter. The transformer expects valid JSONs when decoding (consuming from a subscription) and map() or keyword() when encoding (publishing). Note: Though the struct Yggdrasil.Channel is used. keyword() and map() are also accepted as channels as long as the contain the required keys."},{"ref":"readme.html#postgresql-configuration","title":"Yggdrasil for PostgreSQL - PostgreSQL configuration","module":"readme","type":"extras","doc":"This adapter supports the following list of options: OptionDefaultDescription hostname&quot;localhost&quot;PostgreSQL hostname. port5432PostgreSQL port. username&quot;postgres&quot;PostgreSQL username. password&quot;postgres&quot;PostgreSQL password. database&quot;postgres&quot;PostgreSQL database. max_retries3Amount of retries where the backoff time is incremented. slot_size10Max amount of slots when adapters are trying to reconnect. subscriber_connections1Amount of subscriber connections. publisher_connections1Amount of publisher connections. Note: Concurrency is handled by Postgrex subscriptions in order to reuse database connections. For more information about the available options check Yggdrasil.Settings.Postgres. The following shows a configuration with and without namespace: # Without namespace config :yggdrasil, postgres: [hostname: &quot;postgres.zero&quot;] # With namespace config :yggdrasil, PostgresOne, postgres: [ hostname: &quot;postgres.one&quot;, port: 1234 ] All the available options are also available as OS environment variables. It&#39;s possible to even separate them by namespace e.g: Given two namespaces, the default one and Postgres.One, it&#39;s possible to load the hostname from the OS environment variables as follows: $YGGDRASIL_POSTGRES_HOSTNAME for the default namespace. $POSTGRES_ONE_YGGDRASIL_POSTGRES_HOSTNAME for Postgres.One. In general, the namespace will go before the name of the variable."},{"ref":"readme.html#installation","title":"Yggdrasil for PostgreSQL - Installation","module":"readme","type":"extras","doc":"Using this adapter with Yggdrasil is a matter of adding the available hex package to your mix.exs file e.g: def deps do [{:yggdrasil_postgres, &quot;~&gt; 5.0&quot;}] end"},{"ref":"readme.html#running-the-tests","title":"Yggdrasil for PostgreSQL - Running the tests","module":"readme","type":"extras","doc":"A docker-compose.yml file is provided with the project. If you don&#39;t have a PostgreSQL server, but you do have Docker installed, then you can run: $ docker-compose up --build And in another shell run: $ mix deps.get $ mix test"},{"ref":"readme.html#author","title":"Yggdrasil for PostgreSQL - Author","module":"readme","type":"extras","doc":"Alexander de Sousa."},{"ref":"readme.html#license","title":"Yggdrasil for PostgreSQL - License","module":"readme","type":"extras","doc":"Yggdrasil is released under the MIT License. See the LICENSE file for further details."}]